class ConfigObject {

  constructor () {
    this.decimalPlaces = 8;
    this.intConvertRoundMode = 2;
    this.default_lang = 'pt';
    this.enable_type_casting = true;
    this.idle_input_interval = 5000;
    this.suspend_threshold = 100;
    // this.max_instruction_count = 350250; - automated evaluation limit
    this.max_instruction_count = Number.MAX_SAFE_INTEGER;
  }

  setConfig (opts) {
    for (const key in opts) {
      if(Object.prototype.hasOwnProperty.call(this, key)){
        this[key] = opts[key];
      }
    }
  }
}
const config = new ConfigObject();
export const Config = config;