import { Types } from '../types';
import { LocalizedStrings } from '../../services/localizedStringsService';
import * as VariableValueMenu from './variable_value_menu';
import * as CommandsManagement from '../commands';
import * as GenericExpressionManagement from './generic_expression';
import * as Models from '../ivprog_elements';

export function createFloatingCommand () {
	return $('<div class="ui return created_element"> <i class="ui icon small reply"></i> <span> '+LocalizedStrings.getUI('text_return')+' </span></div>');
}

export function renderCommand (command, function_obj) {
	var el = $('<div class="ui return command_container"> <i class="ui icon small reply command_drag"></i> <i class="ui icon times red button_remove_command"></i> <span class="span_command_spec"> '+LocalizedStrings.getUI('text_return')+' </span>  <div class="expression_elements"></div></div>');
	el.data('command', command);

	addHandlers(command, function_obj, el);

	if (function_obj.return_type != Types.VOID) {
		if (!command.variable_value_menu) {
			command.variable_value_menu = [new Models.VariableValueMenu(VariableValueMenu.VAR_OR_VALUE_TYPES.all, null, null, null, true)];
		}
		GenericExpressionManagement.renderExpression(command, function_obj, el.find('.expression_elements'), command.variable_value_menu);
	} else {
		el.find('.expression_elements').remove();
		command.variable_value_menu = null;
	}
	
	return el;
}

function addHandlers (command, function_obj, return_dom) {

	return_dom.find('.button_remove_command').on('click', function() {
		if (CommandsManagement.removeCommand(command, function_obj, return_dom)) {
			return_dom.fadeOut(400, function() {
				return_dom.remove();
			});
		}
	});
}
